<?php

/* ----------------------------------------------------------------------------------
 *
 * Xaseco plugin paying coppers to first three ranked players.
 *
 * ----------------------------------------------------------------------------------
 *
 * Author: 			ML aka RookieNouse aka nouseforname @ http://www.tm-forum.com
 * Home: 			http://tmf.game-host.org
 * Date: 			22.11.2009
 * Version:			1.0
 * Dependencies: 	none
 *
 * ----------------------------------------------------------------------------------
 *
 * LICENSE: This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
 *
 * ----------------------------------------------------------------------------------
 */
  
Aseco::registerEvent('onEndRace', 'NouseWinning');

function NouseWinning ($aseco) {
	// Load settings
	$count = 0;
	
	$settingsXML = simplexml_load_file('nouse_winning.xml');
	$limit = intval($settingsXML->limit);
	$minservercoppers = intval($settingsXML->minservercoppers);
	$firstplace = intval($settingsXML->firstplace);
	$secondplace = intval($settingsXML->secondplace);
	$thirdplace = intval($settingsXML->thirdplace);
	foreach ($settingsXML->ignoredplayers->ignoredlogin as $login) //Ignored players
		{
		$IgnoredPlayers[$count] = $login;
		$count++;
		}
	
/* ================================================================================= */

	if ($aseco->server->getGame() == 'TMF') {
		// check for TMUF server
		if ($aseco->server->rights) {		
			$aseco->client->query('GetServerCoppers');
			$coppers = $aseco->client->getResponse();
		} else {
			$message = formatText($aseco->getChatMessage('UNITED_ONLY'), 'server');
			$this->Aseco->client->addCall('ChatSendServerMessage', array($aseco->formatColors($message)));
		}
	} else {
		$message = $aseco->getChatMessage('FOREVER_ONLY');
		$aseco->client->addCall('ChatSendServerMessage', array($aseco->formatColors($message)));
	}

	
	if ($coppers >= $minservercoppers) {
		$aseco->client->query('GetCurrentRanking', 50, 0);
		$ranking = $aseco->client->getResponse();
		foreach ($ranking as $key => $var) {
			if ($var[BestTime] > 0 || $var[Score] > 0) {
				$ranks[$key] = array($var[Login], $var[NickName], $var[BestTime], $var[Rank], $var[Score]);
			}
		}
		// check if enough players finished track
		if (count($ranks) >= $limit) {
			if ($ranks[0][0] && $firstplace) {
				$rightsfirst = $aseco->server->players->getPlayer($ranks[0][0])->rights;
				if ($rightsfirst && !in_array($ranks[0][0], $IgnoredPlayers)) {
					$message = '$ff0> '.$ranks[0][1].' $g$z$6c0$s$ifinished at first position and won '.$firstplace.' coppers !!!';
					$aseco->client->addCall('ChatSendServerMessage', array($aseco->formatColors($message)));
					$message = 'You finished at first position and won '.$firstplace.' coppers!'; 
					$aseco->client->addCall('Pay', array($ranks[0][0], $firstplace, $aseco->formatColors($message)));	
				} else {
					$message = '$ff0> '.$ranks[0][1].' $g$z$6c0$s$iuse a non TMU account!!!';
					$aseco->client->addCall('ChatSendServerMessage', array($aseco->formatColors($message)));
				}
			} 
			if ($ranks[1][0] && $secondplace) {
				$rightssecond = $aseco->server->players->getPlayer($ranks[1][0])->rights;
				if ($rightssecond && !in_array($ranks[1][0], $IgnoredPlayers)) {
					$message = '$ff0> '.$ranks[1][1].' $g$z$6c0$s$ifinished at second position and won '.$secondplace.' coppers !!!';
					$aseco->client->addCall('ChatSendServerMessage', array($aseco->formatColors($message)));
					$message = 'You finished at second position and won '.$secondplace.' coppers!'; 
					$aseco->client->addCall('Pay', array($ranks[1][0], $secondplace, $aseco->formatColors($message)));
				} else {
					$message = '$ff0> '.$ranks[1][1].' $g$z$6c0$s$iuse a non TMU account!!!';
					$aseco->client->addCall('ChatSendServerMessage', array($aseco->formatColors($message)));
				}
			} 
			if ($ranks[2][0] && $thirdplace) {
				$rightsthird = $aseco->server->players->getPlayer($ranks[2][0])->rights;
				if ($rightsthird && !in_array($ranks[2][0], $IgnoredPlayers)) {
					$message = '$ff0> '.$ranks[2][1].'  $g$z$6c0$s$ifinished at third position and won '.$thirdplace.' coppers !!!';
					$aseco->client->addCall('ChatSendServerMessage', array($aseco->formatColors($message)));
					$message = 'You finished at third position and won '.$thirdplace.' coppers!'; 
					$aseco->client->addCall('Pay', array($ranks[2][0], $thirdplace, $aseco->formatColors($message)));
				} else {
					$message = '$ff0> '.$ranks[2][1].' $g$z$6c0$s$iuse a non TMU account!!!';
					$aseco->client->addCall('ChatSendServerMessage', array($aseco->formatColors($message)));
				}
			}
		} else {
			$message = '$ff0> $g$z$6c0$s$i Not enough players finished track, Winning payment disabled!!!';
			$aseco->client->addCall('ChatSendServerMessage', array($aseco->formatColors($message)));
		}
	} else {
		$message = '$ff0> $g$z$6c0$s$iServer coppers to low, winning payment disabled. Please donate some.';
		$aseco->client->addCall('ChatSendServerMessage', array($aseco->formatColors($message)));
	}
}
?>